﻿using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Text;
using Devart.Data.SQLite;
using System.Data.Entity;

namespace CrmDemoCodeFirst {

  class Program {

    static void Main(string[] args) {

      // We have turned on SQLiteMonitor to view executed DDL и DML statements in Devart dbMonitor application
      Devart.Data.SQLite.SQLiteMonitor monitor = new Devart.Data.SQLite.SQLiteMonitor() { IsActive = true };

      //--------------------------------------------------------------
      // You use the capability for configuring the behavior of the EF-provider:
      Devart.Data.SQLite.Entity.Configuration.SQLiteEntityProviderConfig config = Devart.Data.SQLite.Entity.Configuration.SQLiteEntityProviderConfig.Instance;
      // Now, you switch off schema name generation while generating DDL scripts and DML:
      config.Workarounds.IgnoreSchemaName = true;
      //--------------------------------------------------------------

      Database.DefaultConnectionFactory = new SQLiteConnectionFactory(".\\..\\..\\", "FailIfMissing=False");

      MyDbContext context = new MySQLiteContext();
      Queries queries = new Queries();

      Console.WriteLine("dotConnect for SQLite: Entity Framework 6 Code-First sample");
      Console.WriteLine();

      queries.GetCategoriesByPrice(context);
      Console.WriteLine();

      queries.GetOrdersSince2007(context);
      Console.ReadKey();
    }
  }

}
