﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Data.Common;
using System.Data.Entity;
using System.Data.Entity.ModelConfiguration;
using System.Linq;
using System.Text;

namespace CrmDemoCodeFirst {

  #region MyDbContext

  /// <summary>
  /// 
  /// </summary>
  public class MyDbContext : DbContext {

    #region Constructors

    public MyDbContext()
      : base() {
    }

    public MyDbContext(DbConnection connection)
      : base(connection, true) {
    }

    #endregion

    protected override void OnModelCreating(DbModelBuilder modelBuilder) {

      modelBuilder.Entity<System.Data.Entity.Infrastructure.EdmMetadata>().ToTable("EdmMetadata", "TEST2");
      // -------------------------------------------------------------
      // ColumnTypeCasingConvention should be removed for dotConnect for Oracle.  
      // This option is obligatory only for SqlClient.  
      // Turning off ColumnTypeCasingConvention isn't necessary for  dotConnect for MySQL, PostgreSQL, and SQLite.  
      // -------------------------------------------------------------
      //modelBuilder.Conventions.Remove<System.Data.Entity.ModelConfiguration.Conventions.ColumnTypeCasingConvention>();
      // -------------------------------------------------------------

      // -------------------------------------------------------------
      // If you don't want to create and use EdmMetadata table for monitoring 
      // the correspondence between the current model and table structure  
      // created in a database, turn off IncludeMetadataConvention:
      // -------------------------------------------------------------
      //modelBuilder.Conventions.Remove<System.Data.Entity.Infrastructure.IncludeMetadataConvention>();
      // -------------------------------------------------------------

      // -------------------------------------------------------------
      // We have defined autoincrement columns in the primary key and non-nullable columns 
      // using DataAnnotation attributes. Similarly, the same can be done with Fluent mapping:
      // -------------------------------------------------------------
      //modelBuilder.ComplexType<AddressType>();

      //modelBuilder.Entity<Product>().HasKey(p => p.ProductID);
      //modelBuilder.Entity<Product>().Property(p => p.ProductID)
      //    .HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);
      //modelBuilder.Entity<Product>().Property(p => p.ProductName)
      //    .IsRequired()
      //    .HasMaxLength(50);


      //modelBuilder.Entity<ProductCategory>().HasKey(p => p.CategoryID);
      //modelBuilder.Entity<ProductCategory>().Property(p => p.CategoryID)
      //    .HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);
      //modelBuilder.Entity<ProductCategory>().Property(p => p.CategoryName)
      //    .IsRequired()
      //    .HasMaxLength(20);

      //modelBuilder.Entity<OrderDetail>().HasKey(p => new { p.OrderID, p.ProductID });

      //modelBuilder.Entity<Order>().HasKey(o => o.OrderID);
      //modelBuilder.Entity<Order>().Property(o => o.OrderID)
      //    .HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);
      //modelBuilder.Entity<Order>().Property(o => o.OrderDate)
      //    .IsRequired();

      //modelBuilder.Entity<Company>().HasKey(c => c.CompanyID);
      //modelBuilder.Entity<Company>().Property(c => c.CompanyID)
      //    .HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);
      //modelBuilder.Entity<Company>().Property(c => c.CompanyName)
      //    .IsRequired()
      //    .HasMaxLength(40);
      //modelBuilder.Entity<Company>().Property(c => c.Web)
      //    .HasMaxLength(100);
      //modelBuilder.Entity<Company>().Property(c => c.Email)
      //    .HasMaxLength(50);

      //modelBuilder.Entity<PersonContact>().HasKey(pc => pc.ContactID);
      //modelBuilder.Entity<PersonContact>().Property(pc => pc.ContactID)
      //    .HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);
      //modelBuilder.Entity<PersonContact>().Property(pc => pc.Title)
      //    .HasMaxLength(8);
      //modelBuilder.Entity<PersonContact>().Property(pc => pc.FirstName)
      //    .HasMaxLength(50);
      //modelBuilder.Entity<PersonContact>().Property(pc => pc.MiddleName)
      //    .HasMaxLength(50);
      //modelBuilder.Entity<PersonContact>().Property(pc => pc.LastName)
      //    .HasMaxLength(50);
      //modelBuilder.Entity<PersonContact>().Property(pc => pc.HomePhone)
      //    .HasMaxLength(25);
      //modelBuilder.Entity<PersonContact>().Property(pc => pc.MobilePhone)
      //    .HasMaxLength(25);
      // -------------------------------------------------------------
    }

    public DbSet<Product> Products { get; set; }
    public DbSet<ProductCategory> ProductCategories { get; set; }
    public DbSet<OrderDetail> OrderDetails { get; set; }
    public DbSet<Order> Orders { get; set; }
    public DbSet<Company> Companies { get; set; }
    public DbSet<PersonContact> PersonContacts { get; set; }
  }

  #endregion
}
